#define _GNU_SOURCE
#include <GdomeSmartDOM.hh>

#include <stdio.h>
#include <string>

using namespace GdomeSmartDOM;
using namespace std;

Node getXBELNode(Document doc)
{
	// Find the main xbel node in `doc'
	NodeList list = doc.get_childNodes();
	for (unsigned long i = 0; i < list.get_length(); i++)
	{
		Node node = list.item(i);
		if (node.get_nodeType() == Node::ELEMENT_NODE &&
				string("xbel") == node.get_nodeName().toC())
			return node;
	}
}

int main(int argc, const char* argv[])
{
	try {
		DOMImplementation impl;
		Document doc = impl.createDocumentFromURI("test.xbel");

		Node xbel = getXBELNode(doc);

		// Find the bookmark node
		NodeList list = xbel.get_childNodes();
		for (unsigned long i = 0; i < list.get_length(); i++)
		{
			Node node = list.item(i);
			if (node.get_nodeType() == Node::ELEMENT_NODE &&
					string("bookmark") == node.get_nodeName().toC())
			{
				xbel.removeChild(node);
				xbel.appendChild(node);
				xbel.appendChild(node);
				break;
			}
		}

		impl.saveDocumentToFile(doc, "test_out.xbel");

		fprintf(stderr, "Done.\n");
	} catch (DOMException& e) {
		fprintf(stderr, "DOMException: %s (%d)\n", e.msg.toC(), e.code);
	} catch (...) {
		fprintf(stderr, "Other exception\n");
	}
	
	return 0;
}

// vim:set ts=4 sw=4:
